﻿using System.Diagnostics;
using System.Media;
using Styx.WoWInternals.WoWObjects;
using ObjectManager = Styx.WoWInternals.ObjectManager;

#region System Namespace

using System;
using System.Linq;

#endregion System Namespace

#region Foreign Namespace
#endregion Foreign Namespace

#region Styx Namespace
using Styx;
using Styx.Plugins;
using Styx.Common;

#endregion Styx Namespace

namespace StalkerAlert
{
    public class StalkerAlert : HBPlugin
    {
        public override string Name { get { return "StalkerAlert"; } }
        public override string Author { get { return "Giwin"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return false; } }

        public Stopwatch Stopwatch = new Stopwatch();

        [Obsolete("Use OnEnable instead")]
        public override void Initialize()
        {
            Logging.Write(Name + " - Loaded Version " + Version);
        }

        public override void Pulse()
        {
            if (!StyxWoW.IsInWorld) return;
            if (!StyxWoW.IsInGame) return;
            const int playerDistanceCheck = 200;
            const int isStalker = 30;
            if (Player() == null || !(Player().Distance < playerDistanceCheck)) return;
            Stopwatch.Start();
            if (!Stopwatch.IsRunning || Stopwatch.Elapsed.Seconds <= isStalker) return;
            LoadSoundAsync();
            Stopwatch.Reset();
        }
        /// <summary>
        /// MSDN - http://msdn.microsoft.com/en-us/library/system.media.soundplayer.playsync(v=vs.110).aspx
        /// </summary>
        private readonly SoundPlayer _soundPlayer = new SoundPlayer();
        private void LoadSoundAsync()
        {
            const string soundFileName = "found.wav"; // Change filename here, make sure to put sound file in the StalkerAlert folder or it won't work. Example "Found.wav" make sure to include the extension,
            // such as .mp3, .wav, .flac etc

            // Note: You may need to change the location specified based on 
            // the location of the sound to be played. 
            _soundPlayer.SoundLocation = "Plugins//StalkerAlert//Sound//" + soundFileName;
            _soundPlayer.LoadCompleted += (sender, args) => Player_LoadCompleted();
            _soundPlayer.LoadAsync();
            
        }

        private void Player_LoadCompleted()
        {
            if (!_soundPlayer.IsLoadCompleted) return;
            _soundPlayer.PlaySync();
        }

        /// <summary>
        ///  End of Copy Pasta, Sourced and Credited
        /// </summary>

        public WoWPlayer Player()
        {
            return ObjectManager.GetObjectsOfType<WoWPlayer>(false, false).FirstOrDefault(player => player != null);
        }
    }
}